<script lang="ts">
  import registrationBg from '$lib/assets/images/home/collaborative.png';
  import Spinner from "$lib/components/ui-elements/Spinner.svelte";
  import TeamDataExport from '$lib/components/ui-elements/TeamDataExport.svelte';
  import ExistingTeamCardSubscribe from '$lib/components/ui-elements/ExistingTeamCardSubscribe.svelte';
  import {
    GetTeamsByEventIdStore,
  } from "$houdini";

  export let eventId: string;
  export let eventName: string | null = null;
  export let hideControls = false;
  export let background = registrationBg;
  export let showExportButton = false;

  const teamStore = new GetTeamsByEventIdStore();

  async function fetchTeams(event_id: string | undefined) {
    if (!event_id) {
      return [];
    }
    await teamStore.fetch(
      { variables: { event_id } }
    );
    return $teamStore.data?.teams || [];
  }
</script>
{#await fetchTeams(eventId)}
  <Spinner />
{:then teams}
  <div class="flex flex-row items-center">
    <span class="font-bold">
      Displaying {teams.length} teams
    </span>
    <div class="pl-1 py-1">
      {#if showExportButton && teams?.length}
        <TeamDataExport teamIds={teams.map((v) => v.id)} filename="{eventName || eventId} Teams" />
      {/if}
    </div>
  </div>
  <div class="grid grid-flow-row grid-cols-1 md:grid-cols-[repeat(auto-fit,_minmax(500px,_1fr))] gap-3 pb-5 mx-auto px-10">
    {#each teams as team_entry}
      <ExistingTeamCardSubscribe teamId={team_entry.id} background={background} {hideControls} />
    {/each}
  </div>
{/await}
